#define WIN32_LEAN_AND_MEAN
#include <windows.h>

BOOL CALLBACK MyMonitorEnumProc(HMONITOR hMonitor, HDC hdcMonitor, LPRECT lprcMonitor, LPARAM dwData)
{
	HWND hWarcraft = (HWND)dwData;
	RECT rWarcraft;
	static int nMonitor = 0;
	static RECT rFirst, rPrev;
	static BOOL bRetVal = TRUE;

	if (!bRetVal)
		return bRetVal;

	if (!lprcMonitor)
		lprcMonitor = &rFirst;

	if (nMonitor == 0)
		rFirst = *lprcMonitor;

	GetWindowRect(hWarcraft, &rWarcraft);

	if (rWarcraft.left != (lprcMonitor->left + (lprcMonitor->right - lprcMonitor->left - rWarcraft.right + rWarcraft.left) / 2)
		&& rWarcraft.top != (lprcMonitor->top + (lprcMonitor->bottom - lprcMonitor->top - rWarcraft.bottom + rWarcraft.top) / 2)
		&& rWarcraft.left >= lprcMonitor->left && rWarcraft.left < lprcMonitor->right && rWarcraft.top >= lprcMonitor->top && rWarcraft.top < lprcMonitor->bottom
		) {
		bRetVal = FALSE;

		SetWindowPos(hWarcraft, HWND_NOTOPMOST, lprcMonitor->left + (lprcMonitor->right - lprcMonitor->left - rWarcraft.right + rWarcraft.left) / 2, lprcMonitor->top + (lprcMonitor->bottom - lprcMonitor->top - rWarcraft.bottom + rWarcraft.top) / 2, 0, 0, SWP_NOSIZE);
	}

	if (nMonitor > 0
		&& rWarcraft.left == (rPrev.left + (rPrev.right - rPrev.left - rWarcraft.right + rWarcraft.left) / 2)
		&& rWarcraft.top == (rPrev.top + (rPrev.bottom - rPrev.top - rWarcraft.bottom + rWarcraft.top) / 2)
		) {
		bRetVal = FALSE;

		SetWindowPos(hWarcraft, HWND_NOTOPMOST, lprcMonitor->left + (lprcMonitor->right - lprcMonitor->left - rWarcraft.right + rWarcraft.left) / 2, lprcMonitor->top + (lprcMonitor->bottom - lprcMonitor->top - rWarcraft.bottom + rWarcraft.top) / 2, 0, 0, SWP_NOSIZE);
	}

	nMonitor++;
	rPrev = *lprcMonitor;

	return bRetVal;
}

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	HWND hWarcraft;
	LONG_PTR lWindowStyle;

	Sleep(10000);
	hWarcraft = GetForegroundWindow();

	if (!hWarcraft) {
		MessageBox(0, "Couldn't find a foreground window.", "FullWindow", MB_ICONERROR);
		return 0;
	}

	lWindowStyle = GetWindowLongPtr(hWarcraft, GWL_STYLE);

	if (lWindowStyle & WS_OVERLAPPEDWINDOW) {
		lWindowStyle &= ~(WS_OVERLAPPEDWINDOW);
		SetWindowLongPtr(hWarcraft, GWL_STYLE, lWindowStyle);
		ShowWindow(hWarcraft, SW_MAXIMIZE);
	}
	else {
		lWindowStyle |= (WS_OVERLAPPEDWINDOW);
		SetWindowLongPtr(hWarcraft, GWL_STYLE, lWindowStyle);
		ShowWindow(hWarcraft, SW_RESTORE);
	}

//	EnumDisplayMonitors(0, 0, MyMonitorEnumProc, (LPARAM)hWarcraft);
//	MyMonitorEnumProc(0, 0, 0, (LPARAM)hWarcraft);

	return 0;
}

void WinMainCRTStartup()
{
	ExitProcess(WinMain(0, 0, 0, 0));
}
